//  DLL containing callback procedure
//  (c) Almaz Sharipov

library keyhook;

uses
  SysUtils, Windows,
  StrUtils; // IsWordPresent and ExtractWord was taken from StrUtils.pas


function KeyboardProc(Code: Integer; wParam: WPARAM; lParam: LPARAM): LResult; stdcall;
var Psw, NNN, Pass : String;
    P : Integer;
    MapHandle1, MapHandle2 : THandle;
    Map1, Map2 : Pointer;
begin
 Result := 0;
 if (lParam < 0) then begin   // works when key is released

// Read magic numbers from mapped memory file
// Warning: no check for possible failures is implemented.

  MapHandle1 := OpenFileMapping(FILE_MAP_READ, true, PChar('NUMBERLIST'));
  Map1 := MapViewOfFile(MapHandle1, FILE_MAP_READ, 0, 0, 64000);
  Pass := String(PChar(Map1));

// Read keyboard buffer from mapped memory file

  MapHandle2 := OpenFileMapping(FILE_MAP_ALL_ACCESS, true, PChar('BUFFER'));
  Map2 := MapViewOfFile(MapHandle2, FILE_MAP_ALL_ACCESS, 0, 0, 16);
  NNN := String(PChar(Map2));

  case wParam of
   48,96  : NNN := NNN + '0';
   49,97  : NNN := NNN + '1';
   50,98  : NNN := NNN + '2';
   51,99  : NNN := NNN + '3';
   52,100 : NNN := NNN + '4';
   53,101 : NNN := NNN + '5';
   54,102 : NNN := NNN + '6';
   55,103 : NNN := NNN + '7';
   56,104 : NNN := NNN + '8';
   57,105 : NNN := NNN + '9';
   8      : NNN := Copy(NNN, 1, Length(NNN) - 1);   // Backspace
   else     NNN := '';
  end;
  if Length(NNN) > 3 then begin 
   if IsWordPresent(NNN, Pass, [' '], P) then begin
    try
     // Search for next word which is the toggled word
     Psw := ExtractWord(P + 1, Pass, [' ']);
     MessageBox(0, PChar(Psw), PChar(NNN), 0);
    except
    end;
    NNN := ''; // Clear buffer
   end;
  end;

// Close mapped views and handles

  FillChar(Map2^, 16, 0);
  StrPCopy(Map2, NNN);
  FlushViewOfFile(Map2, 16);
  UnMapViewOfFile(Map1);
  UnMapViewOfFile(Map2);
  CloseHandle(MapHandle1);
  CloseHandle(MapHandle2);
 end;


end;


exports
  KeyboardProc index 1;

begin
end.
